/*-------------------------------------------------------------------------
 * rtcpsend.c - rtcpsend
 *-------------------------------------------------------------------------
 */

#include <rtp.h>
#include <rtcp.h>
#include <sys/socket.h>

/*------------------------------------------------------------------------
 * rtcpsend - send a (compound) RTCP packet already in network byte order
 *------------------------------------------------------------------------
 */
int
rtcpsend(struct session *psn, struct rtcp *prtcp, int length)
{

	/*
	 * Check for bad length, or unknown destination for
	 * RTCP packets.
	 */
	if (length < RTCP_HEADERSZ || psn->sn_rtcpto.sin_addr.s_addr == INADDR_ANY) 
		return ERROR;
  
	return sendto(psn->sn_rtcpfd, (char *) prtcp, length, 0,  (struct sockaddr *) &psn->sn_rtcpto, sizeof(struct sockaddr_in));
}
