/*-------------------------------------------------------------------------
 * rtcpsendbye.c - rtcpsendbye
 *-------------------------------------------------------------------------
 */

#include <rtp.h>
#include <rtcp.h>
#include <util.h>
#include <stdlib.h>
#include <strings.h>

/*------------------------------------------------------------------------
 * sendrtcpbye - generate and send an RTCP bye message
 *------------------------------------------------------------------------
 */
int
rtcpsendbye(struct session *psn, char *reason)
{

	struct rtcp		*prtcp;
	ssrc_t		        *pssrc;
	char			buf[264];
	struct byereason	*pbyereason;
	int			length;

	if (psn->sn_rtcpto.sin_addr.s_addr == INADDR_ANY)
		return ERROR;

	prtcp = (struct rtcp *) buf;
	pssrc = (ssrc_t *) prtcp->rtcp_data;
	pbyereason = (struct byereason *) (pssrc + 1);

	*pssrc = htonl(psn->sn_ssrc);
	pbyereason->bye_length = min(strlen(reason), 255);
	memcpy(pbyereason->bye_reason, reason, pbyereason->bye_length);

	length = align(RTCP_HEADERSZ + sizeof(ssrc_t) + strlen(reason) + 1, 4);
	if (rtcpheader(prtcp, 1, RTCP_BYE, length) == ERROR)
		return ERROR;

	prtcp->rtcp_length = htons(prtcp->rtcp_length);

	if (rtcpsend(psn, prtcp, length) == ERROR)
		return ERROR;

	return OK;
}
