/*-------------------------------------------------------------------------
 * rtpcheckcollision.c - rtpcheckcollision
 *-------------------------------------------------------------------------
 */

#include <rtp.h>
#include <rtcp.h>
#include <event.h>

/*------------------------------------------------------------------------
 * rtpcheckcollision - check for and resolve SSRC collision
 *------------------------------------------------------------------------
 */
int
rtpcheckcollision(struct session *psn, ssrc_t ssrc)
{

	if(psn->sn_ssrc == ssrc) {
		rtcpsendbye(psn, "SSRC COLLISSION");
		psn->sn_ssrc = rtpmkssrc(psn);
		rtppostevent(psn, EVENT_COLLISION, ssrc, NULL, 0);
		return TRUE;
	}
	return FALSE;
}
