/*-------------------------------------------------------------------------
 * rtpmkssrc.c - rtpmkssrc
 *-------------------------------------------------------------------------
 */

#include <stdlib.h>
#include <rtp.h>
#include <hash.h>

/*------------------------------------------------------------------------
 * rtpmkssrc - generate a unique synchronization source identifier.
 * This does not use the random number generater presend in RFC 1889.
 *------------------------------------------------------------------------
 */
ssrc_t
rtpmkssrc(struct session *psn)
{

	ssrc_t ssrc;

	do {
		ssrc = random();
	} while (psn != NULL ? htget(psn->sn_ssrcs, ssrc) != NULL : 0);

	return ssrc;
}
