/*-------------------------------------------------------------------------
 * rtpstreamoff.c - rtpstreamoff
 *-------------------------------------------------------------------------
 */

#include <stdlib.h>
#include <rtp.h>

/*------------------------------------------------------------------------
 * rtpstreamoff - stop enqueueing packets from a particular stream and 
 * clear its RTP packet queue.
 *------------------------------------------------------------------------
 */
int
rtpstreamoff(struct session *psn, ssrc_t ssrc)
{

	struct stream *pstm;

	pstm = rtpgetstream(psn, ssrc);
	if (pstm == NULL)
		return ERROR;

	pstm->stm_enqueue = FALSE;

	rtpqclear(psn, ssrc);

	rtpreleasestream(psn, pstm);
	return OK;
}
