/*-------------------------------------------------------------------------
 * synreleasestream.c - synreleasestream
 *-------------------------------------------------------------------------
 */

#include <syn.h>
#include <hash.h>
#include <rtp.h>

/*------------------------------------------------------------------------
 * synreleasestream - decrement a synchronization stream's refcnt and 
 * remove if necessary.
 *------------------------------------------------------------------------
 */
int
synreleasestream(struct synsession *pssn, struct synstream *psstm)
{

	if (pthread_mutex_lock(&pssn->ssn_getstreammutex) != 0)
		return ERROR;

	psstm->sstm_refcnt--;

	if (psstm->sstm_refcnt == 0 && psstm->sstm_zombie == TRUE) {
		htdel(pssn->ssn_events.eq_ssrcs, psstm->sstm_ssrc);
		htdel(pssn->ssn_ssrcs, psstm->sstm_ssrc);
	}
	pthread_mutex_unlock(&pssn->ssn_getstreammutex);

	return OK;
}
